<?php

class Encode_Decode_Tool_Admin {

	public function __construct() {

		// Add JS Files
		add_action('wp_head', array($this, 'ende_hook_js'));

		// Add menu in admin setting
		add_action( 'admin_menu', array($this, 'ende_plugin_menu' ));

		// Action for Variation edit Ajax
		add_action('wp_ajax_nopriv_wli_en_de_tool', array($this, 'ende_tool_callback'));

		add_action('wp_ajax_wli_en_de_tool', array($this, 'ende_tool_callback'));

		// Filter for add plugin settings link
		add_filter( 'plugin_action_links_encode-decode-tool/encode-decode-tool.php',  array($this,'ende_add_action_links'));
 
		// Admin ajax variable
		add_action( 'admin_head', array($this, 'ende_admin_global_js_vars' ));

		// Add Admin CSS & JS
		add_action( 'admin_enqueue_scripts', array($this, 'ende_admin_enqueue_CSS_JS'));

		// Admin footer text.
		add_filter( 'admin_footer_text', array( $this, 'ende_admin_footer' ), 1, 2 );

	}

	// General section callback function.
	public function ende_general_section_callback() {
		?>
		<div class="wliplugin-cta-wrap">
			<h1 class="head">We're here to help !</h1>
			<p>Our plugin comes with free, basic support for all users. We also provide plugin customization in case you want to customize our plugin to suit your needs.</p>
			<a href="https://www.weblineindia.com/contact-us.html?utm_source=WP-Plugin&utm_medium=Encode%20Decode%20Tool&utm_campaign=Free%20Support" target="_blank" class="button">Need help?</a>
			<a href="https://www.weblineindia.com/contact-us.html?utm_source=WP-Plugin&utm_medium=Encode%20Decode%20Tool&utm_campaign=Plugin%20Customization" target="_blank" class="button">Want to customize plugin?</a>
		</div>
		<div class="wliplugin-cta-upgrade">
			<p class="note">Want to hire Wordpress Developer to finish your wordpress website quicker or need any help in maintenance and upgrades?</p>
			<a href="https://www.weblineindia.com/contact-us.html?utm_source=WP-Plugin&utm_medium=Encode%20Decode%20Tool&utm_campaign=Hire%20WP%20Developer" target="_blank" class="button button-primary">Hire now</a>
		</div>
		<?php
	}

	// Function For Include Color Picker CSS in Admin
	public function ende_admin_enqueue_CSS_JS($hook_suffix ){

		if( is_admin() ) { 
     
        	// Add the color picker CSS file       
        	wp_enqueue_style( 'wp-color-picker' );

        	// Add the color picker JS file       
        	wp_enqueue_script( 'wp-color-picker' );

        	// Add Admin CSS
			wp_enqueue_style( 'ende-admin-css',ende_EN_DE_TOOL_ASSESTS_URL.'admin/admin_style.css',false,null,'all');
        }
	}

	//Function For Include Plugin JS and CSS
	public function ende_hook_js() {	

		global $wpdb;

		$wli_plugin_status = get_option( 'ende_plugin_status' );

		if( "true" == $wli_plugin_status){

				// Enqueue Encode Decode JS
				wp_enqueue_script("wli-en-de-js",ende_EN_DE_TOOL_ASSESTS_URL.'js/wli_en_de.js',array('jquery'),null,true);  

				// Enqueue Encode Decode CSS
				wp_enqueue_style( 'wli-en-de-css',ende_EN_DE_TOOL_ASSESTS_URL.'css/style.css',false,null,'all');

		}

	}


	// Function for define ajax variables
	public function ende_admin_global_js_vars() {

	    $ajax_url = 'var admin_ajax_params = {"ajax_url":"'. admin_url( 'admin-ajax.php' ) .'"};';

	    echo "<script type='text/javascript'>\n";

	    echo "/* <![CDATA[ */\n";

	    echo $ajax_url;

	    echo "\n/* ]]> */\n";

	    echo "</script>\n";

	}

	// Function for add setting menu
	public function ende_plugin_menu() {

		add_options_page( __('Encode Decode Tool','encode-decode-tool'), 

			__('Encode Decode Tool','encode-decode-tool'), 'manage_options', 'wli-en-de-tool', array($this, 'ende_plugin_menu_option') );

	}

	// Function for admin settings page
	public function ende_plugin_menu_option() {

		if ( !current_user_can( 'manage_options' ) )  {

			wp_die( __( 'Opps... You do not have sufficient permissions to access this page.' ) );

		}

		?>

		<h1 style="line-height: 32px;"><?php _e("Encode Decode Tool",'encode-decode-tool'); ?></h1>

		<div class="wrap">

			<form id="wli_frm_update" method="post" action="">

				<table class="form-table">

					<!-- Call General CTA section -->
					<?php $this->ende_general_section_callback(); ?>

					<tbody>

						<!-- Enable Field Start -->
						<tr>

							<th scope="row"><label for="WLI_plugin_status"><?php _e("Enable Plugin",'encode-decode-tool'); ?></label></th>

							<td><input name="WLI_plugin_status" type="checkbox" id="WLI_plugin_status" value="enable" <?php if("true" == esc_attr(get_option( 'ende_plugin_status' ))){ echo 'checked'; } ?> >

								<p class="description" id="wli_enable_desc"><?php _e("Uncheck this check box to disable the plugin.",'encode-decode-tool'); ?></p>

							</td>

						</tr><!-- Enable Field End -->

						<!-- Encode button Text Field Start -->
						<tr>

							<th scope="row"><label for="wli_encode_btn_txt"><?php _e("Encode Button Link Text",'encode-decode-tool'); ?></label></th>

							<td><input name="wli_encode_btn_txt" type="text" id="wli_encode_btn_txt" value="<?php echo esc_attr(get_option( 'ende_encode_btn_link_text' )); ?>" class="regular-text">

								<p class="description" id="btn_text_desc"><?php _e("Text for encode button link.",'encode-decode-tool'); ?></p>

							</td>

						</tr><!-- Encode button Text Field End -->

						<!-- Encode button text color Field Start -->
						<tr>

							<th scope="row"><label for="wli_encode_btn_text_color"><?php _e("Encode Button Text Color",'encode-decode-tool'); ?></label></th>

							<td><input name="wli_encode_btn_text_color" type="text" id="wli_encode_btn_text_color" value="<?php echo esc_attr(get_option( 'ende_encode_btn_text_color' )); ?>" class="regular-text wli-color">

								<p class="description" id="btn_color_desc"><?php _e("Color for encode button text.",'encode-decode-tool'); ?></p>

							</td>

						</tr><!-- Encode button text color Field End -->

						<!-- Encode button bg color Field Start -->
						<tr>

							<th scope="row"><label for="wli_encode_btn_bg_color"><?php _e("Encode Button Background Color",'encode-decode-tool'); ?></label></th>

							<td><input name="wli_encode_btn_bg_color" type="text" id="wli_encode_btn_bg_color" value="<?php echo esc_attr(get_option( 'ende_encode_btn_bg_color' )); ?>" class="regular-text wli-color">

								<p class="description" id="btn_color_desc"><?php _e("Background Color for encode button.",'encode-decode-tool'); ?></p>

							</td>

						</tr><!-- Encode button bg color Field End -->

						<!-- Decode button Text Field Start -->
						<tr>

							<th scope="row"><label for="wli_decode_btn_txt"><?php _e("Decode Button Link Text",'encode-decode-tool'); ?></label></th>

							<td><input name="wli_decode_btn_txt" type="text" id="wli_decode_btn_txt" value="<?php echo esc_attr(get_option( 'ende_decode_btn_link_text' )); ?>" class="regular-text">

								<p class="description" id="btn_text_desc"><?php _e("Text for decode button link.",'encode-decode-tool'); ?></p>

							</td>

						</tr><!-- Decode button Text Field End -->

						<!-- Decode button text color Field Start -->
						<tr>

							<th scope="row"><label for="wli_decode_btn_text_color"><?php _e("Decode Button Text Color",'encode-decode-tool'); ?></label></th>

							<td><input name="wli_decode_btn_text_color" type="text" id="wli_decode_btn_text_color" value="<?php echo esc_attr(get_option( 'ende_decode_btn_text_color' )); ?>" class="regular-text wli-color">

								<p class="description" id="btn_color_desc"><?php _e("Color for decode button text.",'encode-decode-tool'); ?></p>

							</td>

						</tr><!-- Decode button text color Field End -->

						<!-- Decode button bg color Field Start -->
						<tr>

							<th scope="row"><label for="wli_decode_btn_bg_color"><?php _e("Decode Button Background Color",'encode-decode-tool'); ?></label></th>

							<td><input name="wli_decode_btn_bg_color" type="text" id="wli_decode_btn_bg_color" value="<?php echo esc_attr(get_option( 'ende_decode_btn_bg_color' )); ?>" class="regular-text wli-color">

								<p class="description" id="btn_color_desc"><?php _e("Background Color for decode button.",'encode-decode-tool'); ?></p>

							</td>

						</tr><!-- Decode button bg color Field End -->

						<!-- Select button Text Field Start -->
						<tr>

							<th scope="row"><label for="wli_ende_select_btn_txt"><?php _e("Select Button Link Text",'encode-decode-tool'); ?></label></th>

							<td><input name="wli_ende_select_btn_txt" type="text" id="wli_ende_select_btn_txt" value="<?php echo esc_attr(get_option( 'ende_select_btn_link_text' )); ?>" class="regular-text">

								<p class="description" id="btn_text_desc"><?php _e("Text for select button link.",'encode-decode-tool'); ?></p>

							</td>

						</tr><!-- Select button Text Field End -->

						<!-- Select button text color Field Start -->
						<tr>

							<th scope="row"><label for="wli_ende_select_txt_color"><?php _e("Select Button Text Color",'encode-decode-tool'); ?></label></th>

							<td><input name="wli_ende_select_txt_color" type="text" id="wli_ende_select_txt_color" value="<?php echo esc_attr(get_option( 'ende_select_btn_text_color' )); ?>" class="regular-text wli-color">

								<p class="description" id="btn_color_desc"><?php _e("Color for select button text.",'encode-decode-tool'); ?></p>

							</td>

						</tr><!-- Select button text color Field End -->

						<!-- Select button bg color Field Start -->
						<tr>

							<th scope="row"><label for="wli_ende_select_bg_color"><?php _e("Select Button Background Color",'encode-decode-tool'); ?></label></th>

							<td><input name="wli_ende_select_bg_color" type="text" id="wli_ende_select_bg_color" value="<?php echo esc_attr(get_option( 'ende_select_btn_bg_color' )); ?>" class="regular-text wli-color">

								<p class="description" id="btn_color_desc"><?php _e("Background Color for Select button.",'encode-decode-tool'); ?></p>

							</td>

						</tr><!-- Select button bg color Field End -->

						<!-- Shortcode Info Field Start -->
						<tr>
							<th scope="row"><label><?php _e('Shortcode:', ' encode-decode-tool'); ?> </label></th>
							<td>
								<code>[encode_decode_tool]</code>
								<p class="description">
								<p class="description" id="wli_enable_desc"><?php _e("Use this shortcode in posts and pages.",'encode-decode-tool'); ?></p>
							</td>
						</tr> <!-- Shortcode Info Field End -->

						<!-- Shortcode widget title Field Start -->
						<tr>

							<th scope="row"><label for="wli_ende_short_title_txt"><?php _e("Shortcode Widget Title",'encode-decode-tool'); ?></label></th>

							<td><input name="wli_ende_short_title_txt" type="text" id="wli_ende_short_title_txt" value="<?php echo esc_attr(get_option( 'ende_shortcode_widget_title' )); ?>" class="regular-text">

								<p class="description" id="btn_text_desc"><?php _e("Text for Shortcode widget title.",'encode-decode-tool'); ?></p>

							</td>

						</tr><!-- Shortcode widget title Field End -->

					</tbody>

				</table>

				<?php $wli_img_loader = ende_EN_DE_TOOL_ASSESTS_URL.'images/settings.gif'; ?>

				<img src="<?php echo esc_url($wli_img_loader); ?>" alt="Updating..." height="42" width="50" id="wli_loder_img" style="display:none;" />
				
				<div class="col span_12" id="WLI_form_success" style="display: none;font-size: 14px; color:#0073aa;"></div>

				<p class="submit"><input type="button" name="wli_frm_submit" id="wli_frm_submit" class="button button-primary" value="<?php _e("Save Changes",'encode-decode-tool'); ?>"></p>

			</form>

		</div>

		<?php

		$this->ende_add_script();

	}

	// Function for handle admin form submission
	public function ende_add_script() { ?>

		<script type="text/javascript">

			jQuery(document).ready(function(){

				// Initilize WP color picker
				jQuery('.wli-color').wpColorPicker();

				jQuery('#wli_frm_submit').click(function(e){

					e.preventDefault();

					jQuery('#WLI_form_success').css('display', 'none');

					jQuery('#wli_loder_img').css('display','block');

					//var i = "yes";

					if (jQuery('input#WLI_plugin_status').is(':checked')) { 
						var wli_plguin_state = "true";
					} else {
						var wli_plguin_state = "false";
					}

					var wli_encode_btn_txt = jQuery("#wli_encode_btn_txt").val();
					var wli_encode_btn_txt_color = jQuery("#wli_encode_btn_text_color").val();
					var wli_encode_btn_bg_color = jQuery("#wli_encode_btn_bg_color").val();

					var wli_decode_btn_txt = jQuery("#wli_decode_btn_txt").val();
					var wli_decode_btn_txt_color = jQuery("#wli_decode_btn_text_color").val();
					var wli_decode_btn_bg_color = jQuery("#wli_decode_btn_bg_color").val();

					var wli_ende_select_btn_txt = jQuery("#wli_ende_select_btn_txt").val();
					var wli_ende_select_txt_color = jQuery("#wli_ende_select_txt_color").val();
					var wli_ende_select_bg_color = jQuery("#wli_ende_select_bg_color").val();
					var wli_ende_short_title_txt = jQuery("#wli_ende_short_title_txt").val();

					var data_string = "action=wli_en_de_tool&WLI_plugin_status="+wli_plguin_state+"&wli_encode_btn_txt="+wli_encode_btn_txt+"&wli_encode_btn_txt_color="+wli_encode_btn_txt_color+"&wli_encode_btn_bg_color="+wli_encode_btn_bg_color+"&wli_decode_btn_txt="+wli_decode_btn_txt+"&wli_decode_btn_txt_color="+wli_decode_btn_txt_color+"&wli_decode_btn_bg_color="+wli_decode_btn_bg_color+"&wli_ende_select_btn_txt="+wli_ende_select_btn_txt+"&wli_ende_select_txt_color="+wli_ende_select_txt_color+"&wli_ende_select_bg_color="+wli_ende_select_bg_color+"&wli_ende_short_title_txt="+wli_ende_short_title_txt;

					var ajaxurl = '<?php echo admin_url('admin-ajax.php'); ?>';

					jQuery.ajax({
						type:    "POST",
						url:     admin_ajax_params.ajax_url,
						dataType: 'json',
						data:    data_string,
						// async : false,
						success: function(data){

							jQuery('#wli_loder_img').css('display','none');
							jQuery('#WLI_form_success').css('display', 'block');
							jQuery('#WLI_form_success').text('Settings Updated Successfully!');
						}
					}); 
				});
			});
		</script>
	<?php
	}

	// Function for handle ajax
	public function ende_tool_callback() {

		if( isset($_POST) ) {

			// Plugin status
			update_option( 'ende_plugin_status', sanitize_text_field($_POST['WLI_plugin_status']) );

			// Encode button text
			update_option( 'ende_encode_btn_link_text', sanitize_text_field($_POST['wli_encode_btn_txt']) );

			// Encode button text color
			update_option( 'ende_encode_btn_text_color', sanitize_hex_color($_POST['wli_encode_btn_txt_color']) );

			// Encode button bg color
			update_option( 'ende_encode_btn_bg_color', sanitize_hex_color($_POST['wli_encode_btn_bg_color']) );

			// Decode button text
			update_option( 'ende_decode_btn_link_text', sanitize_text_field($_POST['wli_decode_btn_txt']) );

			// Decode button text color
			update_option( 'ende_decode_btn_text_color', sanitize_hex_color($_POST['wli_decode_btn_txt_color']) );

			// Decode button bg color
			update_option( 'ende_decode_btn_bg_color', sanitize_hex_color($_POST['wli_decode_btn_bg_color']) );

			// Select button text
			update_option( 'ende_select_btn_link_text', sanitize_text_field($_POST['wli_ende_select_btn_txt']) );

			// Select button text color
			update_option( 'ende_select_btn_text_color', sanitize_hex_color($_POST['wli_ende_select_txt_color']) );

			// Select button bg color
			update_option( 'ende_select_btn_bg_color', sanitize_hex_color($_POST['wli_ende_select_bg_color']) );

			// Shortcode widget title
			update_option( 'ende_shortcode_widget_title', sanitize_text_field($_POST['wli_ende_short_title_txt']) );
			
			return array('success' => true);
	    }

		die();
	}

	// Function for add action link
	public function ende_add_action_links( $links_array ){

		array_unshift( $links_array, '<a href="' . admin_url( 'options-general.php?page=wli-en-de-tool' ) . '">Settings</a>' );
		
		return $links_array;
	}

	// Function for showing footer When user is on a Encode Decode Tool related admin page
	public function ende_admin_footer( $text ) {

		global $current_screen;

		if ( ! empty( $current_screen->id ) && strpos( $current_screen->id, 'wli-en-de-tool' ) !== false ) {

			$url  = 'https://wordpress.org/support/plugin/encode-decode-tool/reviews/?filter=5#new-post';
			$wpdev_url  = 'https://www.weblineindia.com/wordpress-development.html?utm_source=WP-Plugin&utm_medium=Encode%20Decode%20Tool&utm_campaign=Footer%20CTA';
			$text = sprintf(
				wp_kses(
					'Please rate our plugin %1$s <a href="%2$s" target="_blank" rel="noopener noreferrer">&#9733;&#9733;&#9733;&#9733;&#9733;</a> on <a href="%3$s" target="_blank" rel="noopener">WordPress.org</a> to help us spread the word. Thank you from the <a href="%4$s" target="_blank" rel="noopener noreferrer">WordPress development</a> team at WeblineIndia.',
					array(
						'a' => array(
							'href'   => array(),
							'target' => array(),
							'rel'    => array(),
						),
					)
				),
				'<strong>"Encode Decode Tool"</strong>',
				$url,
				$url,
				$wpdev_url
			);
		}

		return $text;
	}
}

// Class Obj.
new Encode_Decode_Tool_Admin;
?>