<?php

//Define Widget Class
class Encode_Decode_Tool_Widget extends WP_Widget {

	// Class Constructor
	function __construct() {
		parent::__construct(
			// widget ID
			'Encode_Decode_Tool_Widget',
			// widget name
			__('Encode Decode Tool', 'encode-decode-tool'),
			// widget description
			array( 'description' => __( 'Simple widget for Encode Decode Tool', 'encode-decode-tool' ), )
		);
	}

	// Function for widget output
	public function widget( $args, $instance ) {
	
		$title = apply_filters( 'widget_title', $instance['title'] );
		echo $args['before_widget'];
		//if title is present
		if ( ! empty( $title ) )
			echo $args['before_title'] . $title . $args['after_title'];
		//output
		echo __( 'Convert content to ASCII character-set.', 'encode-decode-tool' );
		
		// Get Encode button text
		if( "" == get_option( "ende_encode_btn_link_text" ) ){

			$encode_btn_text = __('Encode', 'encode-decode-tool');

		}else{

			$encode_btn_text = get_option( "ende_encode_btn_link_text" );

		}

		// Get Encode button text color
		if( "" == get_option( "ende_encode_btn_text_color" ) ){

			$encode_btn_text_color = sanitize_hex_color("#000000");

		}else{

			$encode_btn_text_color = get_option( "ende_encode_btn_text_color" );

		}

		// Get Encode button bg color
		if( "" == get_option( "ende_encode_btn_bg_color" ) ){

			$encode_btn_bg_color = sanitize_hex_color("#ffbd33");

		}else{

			$encode_btn_bg_color = get_option( "ende_encode_btn_bg_color" );

		}

		// Get Decode button text
		if( "" == get_option( "ende_decode_btn_link_text" ) ){

			$decode_btn_text = __('Decode', 'encode-decode-tool');

		}else{

			$decode_btn_text = get_option( "ende_decode_btn_link_text" );

		}

		// Get Decode button text color
		if( "" == get_option( "ende_decode_btn_text_color" ) ){

			$decode_btn_text_color = sanitize_hex_color("#000000");

		}else{

			$decode_btn_text_color = get_option( "ende_decode_btn_text_color" );

		}

		// Get Decode button bg color
		if( "" == get_option( "ende_decode_btn_bg_color" ) ){

			$decode_btn_bg_color = sanitize_hex_color("#ffbd33");

		}else{

			$decode_btn_bg_color = get_option( "ende_decode_btn_bg_color" );

		}

		// Get Select button text
		if( "" == get_option( "ende_select_btn_link_text" ) ){

			$select_btn_text = __('Select All', 'encode-decode-tool');

		}else{

			$select_btn_text = get_option( "ende_select_btn_link_text" );

		}

		// Get Select button text color
		if( "" == get_option( "ende_select_btn_text_color" ) ){

			$select_btn_text_color = sanitize_hex_color("#000000");

		}else{

			$select_btn_text_color = get_option( "ende_select_btn_text_color" );

		}

		// Get Select button bg color
		if( "" == get_option( "ende_select_btn_bg_color" ) ){

			$select_btn_bg_color = sanitize_hex_color("#ffbd33");

		}else{

			$select_btn_bg_color = get_option( "ende_select_btn_bg_color" );

		}


		?>
		<div class="en-de-footer-wrapper">
			<textarea cols="80" rows="10" placeholder="Please enter your content here..." class="content-holder" id="content-holder"></textarea>
			<div class="btn-wrapper">
	        	<button class="btn-decode" title="Decode" style="color: <?php echo esc_html($decode_btn_text_color); ?>; background-color: <?php echo esc_html($decode_btn_bg_color); ?>"><?php echo esc_html($decode_btn_text); ?></button>
	        	<button class="btn-encode" title="Encode" style="color: <?php echo esc_html($encode_btn_text_color); ?>; background-color: <?php echo esc_html($encode_btn_bg_color); ?>"><?php echo esc_html($encode_btn_text); ?></button>
	        	<button class="btn-select btn-select-foot" style="color: <?php echo esc_html($select_btn_text_color); ?>; background-color: <?php echo esc_html($select_btn_bg_color); ?>" title="Select All" data-clipboard-target=".content-holder"><?php echo esc_html($select_btn_text); ?></button>
	        	<button class="btn-select btn-select-short" style="color: <?php echo esc_html($select_btn_text_color); ?>; background-color: <?php echo esc_html($select_btn_bg_color); ?>" title="Select All" data-clipboard-target=".content-holder"><?php echo esc_html($select_btn_text); ?></button>
	        </div>
    	</div>
        <?php
		echo $args['after_widget'];
	}

	// Function for Widget form
	public function form( $instance ) {
	
		if ( isset( $instance[ 'title' ] ) )
			$title = $instance[ 'title' ];
		else
			$title = __( 'Encode Decode Tool', 'encode-decode-tool' );
		?>

		<p>
			<label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php _e( 'Title:' ); ?></label>
			<input class="widefat" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" type="text" value="<?php echo esc_attr( $title ); ?>" />
		</p>

		<?php
	}

	// Function for Update widget
	public function update( $new_instance, $old_instance ) {

		$instance = array();
		$instance['title'] = ( ! empty( $new_instance['title'] ) ) ? strip_tags( $new_instance['title'] ) : '';

	return $instance;
	}
}

// Function for Register Widget.
function ende_register_en_de_widget() {
	register_widget( 'Encode_Decode_Tool_Widget' );
}

// Add action for widget register
add_action( 'widgets_init', 'ende_register_en_de_widget' );