<?php
/**
 * The plugin bootstrap file
 *
 * This file is read by WordPress to generate the plugin information in the plugin
 * admin area. This file also includes all of the dependencies used by the plugin,
 * registers the activation and deactivation functions, and defines a function
 * that starts the plugin.
 *
 * @link              https://www.weblineindia.com/
 * @since             1.0.0
 * @package           Encode_Decode_Tool
 *
 * @wordpress-plugin
 * Plugin Name:       Encode Decode Tool
 * Plugin URI:        https://wordpress.org/plugins/encode-decode-tool
 * Description:       Encode or Decode your content into ASCII character-set.
 * Version:           1.0.1
 * Author:            Weblineindia
 * Author URI:        https://www.weblineindia.com/
 * License:           GPL-2.0+
 * License URI:       http://www.gnu.org/licenses/gpl-2.0.txt
 * Text Domain:       encode-decode-tool
 * Domain Path:       /languages
 */

if ( ! defined( 'ABSPATH' ) ) { exit; } // Exit on direct access.

// Define Plugin and Plugin Assets Path
if ( ! defined( 'ende_EN_DE_TOOL_ASSESTS_URL' ) ) {

	define('ende_EN_DE_TOOL_ASSESTS_URL', plugin_dir_url(__FILE__).'assets/');

}

// Include Admin Page
require 'admin/class-encode-decode-tool-admin.php';

// Register Plugin activation hook
register_activation_hook(__FILE__, 'ende_encode_decode_tool_enable_plugin');

// Set default plugin state - TRUE
function ende_encode_decode_tool_enable_plugin() {

    update_option( 'ende_plugin_status', 'true');

}

// Get Plugin current status
$wli_plugin_status = get_option( 'ende_plugin_status' );

if( "true" == $wli_plugin_status){
	
	// Include Widget File
	require 'admin/class-encode-decode-tool-widget.php';

	// Include Shortcode File
	require 'public/encode-decode-tool-public.php';
}

?>